export function debounce (cb, timeout = 800) {
  cb.debounseTimer = null
  return function () {
    if (cb.debounseTimer) {
      clearTimeout(cb.debounseTimer)
      cb.debounseTimer = null
    }
    cb.debounseTimer = setTimeout(() => {
      cb.call(this, ...arguments)
    }, timeout)
  }
}
