import EmptyLayout from '../packages/EmptyLayout/index'
import FwAffixTable from '../packages/FwAffixTable/index'
import FwBadge from '../packages/FwBadge/index'
import FwBreadcrumb from '../packages/FwBreadcrumb/index'
import FwRadioTab from '../packages/FwRadioTab/index'
import FwSteps from '../packages/FwSteps/index'
import ImageHolder from '../packages/ImageHolder/index'
import ImageViewer from '../packages/ImageViewer/index'
import ImportModal from '../packages/ImportModal/index'
import InputNumberWithAddon from '../packages/InputNumberWithAddon/index'
import LongTextPopover from '../packages/LongTextPopover/index'
import TitleAndOperate from '../packages/TitleAndOperate/index'
import FwFlexCard from '../packages/FwFlexCard/index'

import { version } from '../package.json'
const components = [
  EmptyLayout,
  FwAffixTable,
  FwBadge,
  FwBreadcrumb,
  FwRadioTab,
  FwSteps,
  ImageHolder,
  ImageViewer,
  ImportModal,
  InputNumberWithAddon,
  LongTextPopover,
  TitleAndOperate,
  FwFlexCard
]
const install = function (Vue) {
  // 判断是否安装
  if (install.installed) {
    return
  }
  components.forEach((component) => {
    Vue.component(component.name, component)
  })
}

if (typeof window !== 'undefined' && window.Vue) {
  install(window.Vue)
}

export default {
  version,
  install,
  ...components
}
